{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: dc_public_server_reg.pas,v 0.2 2002/03/026 16:00 suxxx $
}

{ here opendcd register the hub at the neo-modus public server }

{
changes:
* 0.2 changing that the hub registers at the publicserver every 14 minutes
}


unit dc_public_server_reg;

interface

uses
    { kylix / delphi units}
    SysUtils,
    classes,
    { opendcd units }
    declare_types,
    declare_vars,
    global_functions,
    global_multiconsol_functions,
    threadtimer,
    { indy units }
    IdBaseComponent,
    IdComponent,
    IdTCPConnection,
    IdGlobal,
    IdTCPClient,
    IdIOHandlerSocket;

type
 TDCPublicRegister = class(TComponent)
 protected
 _RegisterHubTimer : TThreadTimer;
 _RegisterTCP: TIdTCPClient;
  procedure _RegisterHubTimerEvent;
 private
  procedure RegisterTCPConnected(Sender: TObject);
 public
  constructor Create();
  destructor Destroy();
 end;

implementation


    
const HubRegisterServer = 'vandel405.dynip.com';

constructor TDCPublicRegister.Create();
begin
inherited Create(nil);
_RegisterTCP := TIdTCPClient.Create(nil);
_RegisterTCP.Host := HubRegisterServer;
_RegisterTCP.Port := 2501;
_RegisterTCP.OnConnected := RegisterTCPConnected;
_RegisterHubTimer := TThreadTimer.Create(840);
_RegisterHubTimer.OnTimer := _RegisterHubTimerEvent;
end;

destructor TDCPublicRegister.Destroy();
begin
 inherited Destroy();
 _RegisterHubTimer.Terminate;
 _RegisterHubTimer.Destroy;
 _RegisterTCP.Destroy;
end;

procedure TDCPublicRegister._RegisterHubTimerEvent();
begin
if HubSettings.HubRegisteratPublic = true then
begin
 try
  _RegisterTCP.Connect();
 except
  ConsoleWriteln('[REG] Could not connect to masterserver',1,0,0);
 end;
end;
end;

procedure TDCPublicRegister.RegisterTCPConnected(Sender: TObject);
var d:string;
    dakey:string;
    port:string;
begin
while _RegisterTCP.connected = true do
begin
 d := _RegisterTCP.ReadLn('|');

 if copy(d,0,5) = '$Lock' then
 begin
  dakey := createkey(copy(d,7,length(d)),(_Registertcp.IOHandler as TIdIOHandlerSocket).Binding.Port + ((_Registertcp.IOHandler as TIdIOHandlerSocket).Binding.Port) shr 8);
  port := '';
  if HubSettings.HubPort <> 411 then port := ':' + inttostr(HubSettings.HubPort);
  _RegisterTCP.Write('$Key ' + dakey +  '|' + HubSettings.HubName + '|' + HubSettings.HubAddress + port + '|' + HubSettings.HubDescription + '|' + inttostr(DCHub.HubUsers.count) + '|0|');
  ConsoleWriteln('[REG] Register successfully ( ' + HubSettings.HubName + '|' + HubSettings.HubAddress + port + '|' + HubSettings.HubDescription + '|' + inttostr(DCHub.HubUsers.Count) + '|0| )',1,0,0);
  _RegisterTCP.Disconnect;
 end;
end;
end;

end.
