{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: global_functions.pas,v 0.1 2002/01/03 16:30 suxxx $
}

{ here all global functiosn stored }
unit global_functions;

interface
uses
    { kylix / delphi units}
    Math,
    SysUtils,
    {$IFNDEF LINUX} Windows, {$ENDIF}
    { indy units }
    IdGlobal,
    IdIPWatch,
    { opendcd units }
     declare_types,
     declare_vars;

{ lock and key generation functions }
function createkey(inlock : bigstring;xorwith:byte) : xtrastring;
function createvalidlock() : bigstring;
function ns(value:integer) :integer;
procedure DetectOSVersion();
function splitstring(InString :string;SplitChar:char = ' '): StringArray;
function UnixToDateTime(const AValue: Int64): TDateTime;
function DateTimeToUnix(const AValue: TDateTime): Int64;
function Isanumber(instring:string):boolean;
procedure setupserver();
procedure AddIllegalUser(username:string);
function IsIllegalUser(username:string):boolean;
implementation

{ *** lock and key generation functions *** }

{litte help function for createkey}
function ns(value:integer) :integer;
begin
result := (value shl 4) or (value shr 4);
end;

{Original Key calculating function by eric (Author of DCTC)
 Ported from C to Delphi by SuxXx }
function createkey(inlock : bigstring;xorwith:byte) : xtrastring;
var i:integer;
    key : string;
    key2 : string;
    lock: string;
begin
lock := copy(inlock,0,pos('Pk',inlock) - 2);

setlength(key , length(lock));
key[1] := chr( ns(ord(lock[1]) xor ord(lock[length(lock)]) xor ord(lock[length(lock) - 1]) xor xorwith) );

for i := 2 to length(lock) do
begin
key[i] := chr( ns(ord(lock[i]) xor ord(lock[i-1])));
end;

for i := 1 to length(key) do
begin
case key[i] of
chr(0): key2 := key2 + '/%DCN000%/';
chr(5): key2 := key2 + '/%DCN005%/';
chr(36): key2 := key2 + '/%DCN036%/';
chr(96): key2 := key2 + '/%DCN096%/';
chr(124): key2 := key2 + '/%DCN124%/';
chr(126): key2 := key2 + '/%DCN126%/';
else
key2 := key2 + key[i];
end;
end;
result := key2;
end;


{creates a valid lock key}
function createvalidlock():bigstring;
var tmplock:string;
    i,n:integer;
begin
randomize;

n := 30 + RandomRange(1,50);
setlength(tmplock,n);
for i := 1 to n do tmplock[i] := chr(RandomRange(37,122));
tmplock := tmplock + ' Pk=opendcd';
result := tmplock;
end;

procedure DetectOSVersion();
var 
{$IFDEF LINUX}
    TxFile:textfile;
    readstr:string;
{$ELSE}
    winVersion : OSVERSIONINFO;
{$ENDIF}
begin
{$IFDEF LINUX}
if fileexists('/etc/SuSE-release') = true then
begin
AssignFile (TxFile,'/etc/SuSE-release');
reset(TxFile);
readln(TxFile,readstr);
OSVersion := readstr;
end
else if fileexists('/etc/redhat-release') = true then
begin
AssignFile (TxFile,'/etc/redhat-release');
reset(TxFile);
readln(TxFile,readstr);
OSVersion := readstr;
end
else if fileexists('/etc/slackware-version') = true then
begin
AssignFile (TxFile,'/etc/slackware-version');
reset(TxFile);
readln(TxFile,readstr);
OSVersion := 'Slackware ' + readstr;
end
else
begin
OSVersion := 'Linux'
end;
{$ELSE}
   winVersion.dwOSVersionInfoSize := sizeOf(OSVERSIONINFO);
   getVersionEx(winVersion);
   case winVersion.dwPlatformId of
     VER_PLATFORM_WIN32s : OSVersion := 'Windows';
     VER_PLATFORM_WIN32_WINDOWS : if (winVersion.dwMinorVersion > 50) then
                                    OSVersion := 'Windows ME'
                                  else
                                  begin
                                    if winVersion.dwMinorVersion >= 10 then
                                     OSVersion := 'Windows 98'
                                    else
                                     OSVersion := 'Windows 95';
                                  end;
     VER_PLATFORM_WIN32_NT : if (winVersion.dwMajorVersion > 4) then
                                begin
                                 if winVersion.dwMinorVersion > 0 then
                                 OSVersion := 'Windows XP'
                                else
                                 OSVersion := 'Windows 2000';
                                end
                             else
                                OSVersion := 'Windows NT';
   end;

   OSVersion := OSVersion + ' (v' + intToStr(winVersion.dwMajorVersion) + '.' +
         intToStr(winVersion.dwMinorVersion) + ' build ' +
         intToStr(winVersion.dwBuildNumber) + ')';

{$ENDIF}
end;

{ splits a string into a array }
{ split caracter is a space }
function splitstring(InString :string;SplitChar:char = ' '): StringArray;
var TMP1:StringArray;
    TMP2:string;
    i:integer;
begin
i := -1;
TMP2 := trim(InString);
if length(TMP2) > 0 then
begin

while i <> 0 do
begin
 i := pos(SplitChar,TMP2);
 setlength(TMP1,length(TMP1)+1);
 if i <> 0 then
 begin
  TMP1[length(TMP1) -1] := trim(copy(TMP2,1,i - 1));
  TMP2 := copy(TMP2,i + 1,length(TMP2));
 end
 else
 begin
  TMP1[length(TMP1) -1] := trim(TMP2);
  TMP2 := '';
 end;
end;
end;

result := TMP1;
end;

function DateTimeToUnix(const AValue: TDateTime): Int64;
begin
  Result := Round((AValue - UnixDateDelta) * SecsPerDay);
end;

function UnixToDateTime(const AValue: Int64): TDateTime;
begin
  Result := AValue / SecsPerDay + UnixDateDelta;
end;

{checks if a straing only contains numbers}
function Isanumber(instring:string):boolean;
var i:integer;
    isnr:boolean;
begin
isnr := false;
if length(instring) > 0 then isnr := true;
for i := 1 to length(instring) do
begin
 if isnumeric(instring[i]) = false then isnr := false;
end;

result := isnr;
end;


procedure setupserver();
var readstr:string;
    MyFile:file;
    CurIP:TIdIPWatch;
label ReInsertHubName,ReInsertHubDescription,ReInsertHubAddress, ReInsertRedirectAddress,ReInstertRedirectAllUsers,ReInstertRedirectIfHubIsFull,ReInstertIsRegisteredUsersOnly,ReInstertDisablePassiveSearch,ReInsertRegisteratPublic;
begin
 CurIP := TIdIPWatch.Create(nil);
 //only on localconsole
 AssignFile (MyFile,'settings.dat');
 writeln('-------------------------------------------------------------------------------');
 writeln('Welcome to OpenDCd.');
 writeln('You now could configure your OpenDCd Server.');
ReInsertHubName:
 if (HubSettings.HubName = '') then HubSettings.HubName := 'OpenDCd';
 write('Please insert the HubName [' + HubSettings.HubName + ']: ');
 readln(readstr);
 if (length(readstr) > 20) then
 begin
  writeln('The Hubname has too many characters. Please insert a new one.');
  goto ReInsertHubName;
 end;
 
 if (readstr = '') then readstr := HubSettings.HubName;
 HubSettings.HubName := readstr;

ReInsertHubDescription:
 if (HubSettings.HubDescription = '') then HubSettings.HubDescription := 'OpenDCd Server';
 write('Please insert a HubDescription for Public Server [' + HubSettings.HubDescription + ']: ');
 readln(readstr);
 if (length(readstr) > 100) then
 begin
  writeln('The HubDescription has too many characters. Please insert a new one.');
  goto ReInsertHubDescription;
 end;
 
 if (readstr = '') then readstr := HubSettings.HubDescription;
 HubSettings.HubDescription := readstr;


ReInsertHubAddress:
 if (HubSettings.HubAddress = '') then HubSettings.HubAddress := CurIp.LocalIP;
 write('Please insert a HubAddress (IP or DNS} for Public Server [' + HubSettings.HubAddress + ']: ');
 readln(readstr);
 if (length(readstr) > 100) then
 begin
  writeln('The HubAddress has too many characters. Please insert a new one.');
  goto ReInsertHubAddress;
 end;
 
 if (readstr = '') then readstr := HubSettings.HubAddress;
 HubSettings.HubAddress := readstr;


 if (HubSettings.HubPort = 0) then HubSettings.HubPort := 411;
 write('Please insert the Port where the Hub should listen [' + inttostr(HubSettings.HubPort) +']: ');
 readln(readstr);
 
 if (readstr = '') then readstr := inttostr(HubSettings.HubPort);
 HubSettings.HubPort := strtoint(readstr);

 if (HubSettings.HubMaxUsers = 0) then HubSettings.HubMaxUsers := 500;
 write('Please insert the Userlimit [' + inttostr(HubSettings.HubMaxUsers) + ']: ');
 readln(readstr);
 
 if (readstr = '') then readstr := inttostr(HubSettings.HubMaxUsers);
 HubSettings.HubMaxUsers := strtoint(readstr);

 if (HubSettings.HubMinFileShare = 0) then HubSettings.HubMinFileShare := 0;
 write('Please insert the min. Bytes to share ['+ inttostr(HubSettings.HubMinFileShare) + ']: ');
 readln(readstr);

 if (readstr = '') then readstr := inttostr(HubSettings.HubMinFileShare);
 HubSettings.HubMinFileShare := strtoint64(readstr);
 
 ReInsertRedirectAddress:
 if (HubSettings.HubRedirectAddress = '') then HubSettings.HubRedirectAddress := 'none';
 write('Please insert the Redirect Address [' + HubSettings.HubRedirectAddress + ']: ');
 readln(readstr);
 if (length(readstr) > 50) then
 begin
  writeln('The Redirect Address has too many characters. Please insert a new one.');
  goto ReInsertRedirectAddress;
 end;

 if (readstr = '') then readstr := HubSettings.HubRedirectAddress;
 HubSettings.HubRedirectAddress := readstr;


 ReInstertRedirectAllUsers:
 if HubSettings.HubRedirectAllUsers then
 begin
  write('Should openDCd redirect all Users to the RedirectAddress? [Yn]: ');
 end
 else
 begin
  write('Should openDCd redirect all Users to the RedirectAddress? [yN]: ');
 end;
 readln(readstr);
 if readstr = 'y' then
 begin
  HubSettings.HubRedirectAllUsers := true;
 end
 else if readstr = 'n' then
 begin
  HubSettings.HubRedirectAllUsers := false;
 end
 else if readstr = '' then
 begin
  // nothing
 end
 else
 begin
  writeln('Error: Please insert a y or a n.');
  goto ReInstertRedirectAllUsers;
 end;

 ReInstertRedirectIfHubIsFull:
 if HubSettings.HubRedirectIfHubIsFull then
 begin
  write('Should openDCd redirect all new Users if Hub is Full? [Yn]: ');
 end
 else
 begin
  write('Should openDCd redirect all new Users if Hub is Full? [yN]: ');
 end;
 readln(readstr);
 if readstr = 'y' then
 begin
  HubSettings.HubRedirectIfHubIsFull := true;
 end
 else if readstr = 'n' then
 begin
  HubSettings.HubRedirectIfHubIsFull := false;
 end
 else if readstr = '' then
 begin
  // nothing
 end
 else
 begin
  writeln('Error: Please insert a y or a n.');
  goto ReInstertRedirectIfHubIsFull;
 end;


 ReInstertIsRegisteredUsersOnly:
 if HubSettings.HubIsRegisteredUsersOnly then
 begin
  write('Should only registered users could join this Hub? [Yn]: ');
 end
 else
 begin
  write('Should only registered users could join this Hub? [yN]: ');
 end;
 readln(readstr);
 if readstr = 'y' then
 begin
  HubSettings.HubIsRegisteredUsersOnly := true;
 end
 else if readstr = 'n' then
 begin
  HubSettings.HubIsRegisteredUsersOnly := false;
 end
 else if readstr = '' then
 begin
  // nothing
 end
 else
 begin
  writeln('Error: Please insert a y or a n.');
  goto ReInstertIsRegisteredUsersOnly;
 end;

  ReInstertDisablePassiveSearch:
 if HubSettings.HubDisablePassiveSearch then
 begin
  write('Disable Passive searching at this Hub? (lower traffic) [Yn]: ');
 end
 else
 begin
  write('Disable Passive searching at this Hub? (lower traffic)) [yN]: ');
 end;
 readln(readstr);
 if readstr = 'y' then
 begin
  HubSettings.HubDisablePassiveSearch := true;
 end
 else if readstr = 'n' then
 begin
  HubSettings.HubDisablePassiveSearch := false;
 end
 else if readstr = '' then
 begin
  // nothing
 end
 else
 begin
  writeln('Error: Please insert a y or a n.');
  goto ReInstertDisablePassiveSearch;
 end;



 ReInsertRegisteratPublic:
 if HubSettings.HubRegisteratPublic then
 begin
  write('Should this Hub registered at the Public DC Server? [Yn]: ');
 end
 else
 begin
  write('Should this Hub registered at the Public DC Server? [yN]: ');
 end;
 readln(readstr);
 if readstr = 'y' then
 begin
  HubSettings.HubRegisteratPublic := true;
 end
 else if readstr = 'n' then
 begin
  HubSettings.HubRegisteratPublic := false;
 end
 else if readstr = '' then
 begin
  // nothing
 end
 else
 begin
  writeln('Error: Please insert a y or a n.');
  goto ReInsertRegisteratPublic;
 end;

 HubSettings.HubMinShareSlots := '0';

 Rewrite(MyFile, 1);
 Blockwrite(MyFile,HubSettings,sizeof(HubSettings));

 CurIP.Free;
end;

{adds a new usersname to illegaluserarray }
procedure AddIllegalUser(username:string);
begin
setlength(illegalusers,length(illegalusers)+1);
illegalusers[length(illegalusers) - 1] := username;
end;

{checks if illegal user }
function IsIllegalUser(username:string):boolean;
var n :integer;
    done:boolean;
begin
done := false;

for n := 0 to length(illegalusers) - 1 do
begin
 if uppercase(illegalusers[n]) = copy(uppercase(username),1,length(illegalusers[n])) then done := true; 
end;

result := done;
end;

end.
