{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: global_linkedserver_functions.pas,v 0.1 2002/01/03 16:30 suxxx $
}

{ here all linked server functions tored }

{
todos:
* cleaning code
}
unit global_linkedserver_functions;

interface

uses
     { kylix / delphi units }
     SysUtils,
     { opendcd units }
     declare_types,
     declare_vars,
     global_multiconsol_functions;

function LoadLinkedServer():string;
procedure SaveLinkedServer();

function AddLinkedServer(ServerIP:string;ServerPort:integer;ServerPassword:string):boolean;
function RemoveLinkedServer(id:integer):boolean;

function IsAllowedLinkedServer(ServerIP:string;ServerPort:integer;ServerPassword:string):integer;
function SetLinkedServerActive(ServerIP:string;ServerPort:integer;ServerPassword:string):boolean;
function IsOnlineLinkedServer(ServerIP:string;ServerPort:integer):integer;

implementation

{ loads all linked servers }
function loadlinkedserver():string;
var MyFile:file;
    i:integer;
    tmpserver:TLinkedServer;
begin
AssignFile (MyFile,'servers.dat');
setlength(linkedservers,0);
if (fileexists('servers.dat') = true) then
begin
reset(MyFile,1);
if (FileSize(MyFile) >= sizeof(tmpserver))  then
begin

i := 1;
while (i < FileSize(MyFile)) do
begin
blockread(MyFile,tmpserver,sizeof(tmpserver));
setlength(linkedservers,length(linkedservers) +1);
linkedservers[length(linkedservers) - 1] := tmpserver;
linkedservers[length(linkedservers) - 1].HubStatus := 1;
i := i + sizeof(tmpserver);
end;
result := inttostr(length(linkedservers)) + ' Server loaded';
end;
end;
end;

{saves linked servers }
procedure savelinkedserver();
var MyFile:file;
    i:integer;
    tmpserver:TLinkedServer;
begin
AssignFile (MyFile,'servers.dat');
Rewrite(MyFile, 1);
for i := 0 to length(linkedservers) -1 do
begin
tmpserver := linkedservers[i];
tmpserver.HubStatus := 1;
Blockwrite(MyFile,tmpserver,sizeof(tmpserver));
end;
end;

{ adding new linked server to list}
function AddLinkedServer(ServerIP:string;ServerPort:integer;ServerPassword:string):boolean;
begin
setlength(linkedservers,length(linkedservers)+1);
linkedservers[length(linkedservers) -1].HubIP := ServerIP;
linkedservers[length(linkedservers) -1].HubPort := ServerPort;
linkedservers[length(linkedservers)- 1].HubPassword := ServerPassword;
linkedservers[length(linkedservers)- 1].HubStatus := 1;
result:=true;
end;

{ removing linked server }
function RemoveLinkedServer(id:integer):boolean;
var count:integer;
begin
 count := length(linkedservers);
 if count >= id then
 begin
  id := id -1;
  if id <> -1 then
  begin
   if count = 1 then
   begin
    setlength(linkedservers,0);
    result := true;
   end
   else
   begin
    move(linkedservers[id +1],linkedservers[id], (count - id) * sizeof(TLinkedServer));
    setlength(linkedservers,count -1);
    result := true;
   end;
  end
  else
  begin
   result := false;
  end;
 end
 else
 begin
  result := false;
 end;
end;

{ checking if password is ok }
function IsAllowedLinkedServer(ServerIP:string;ServerPort:integer;ServerPassword:string):integer;
var i,j:integer;
begin
j := -1;
for i := 0 to (length(linkedservers) -1) do
begin
if ((linkedservers[i].HubIP = ServerIP) and (linkedservers[i].HubPort = ServerPort) and (linkedservers[i].HubPassword = ServerPassword)) then j := i;
end;
result := j;
end;

{ setting linked server active }
function SetLinkedServerActive(ServerIP:string;ServerPort:integer;ServerPassword:string):boolean;
var i,j:integer;
begin
j := -1;
for i := 0 to (length(linkedservers) -1) do
begin
 if ((linkedservers[i].HubIP = ServerIP) and (linkedservers[i].HubPort = ServerPort) and (linkedservers[i].HubPassword = ServerPassword)) then
 begin
  j := i;
  linkedservers[i].HubStatus := 2;
 end;
end;
if j = -1 then
begin
 result := false;
end
else
begin
 result := true;
end;
end;

{ checking if linked server is onlline }
function IsOnlineLinkedServer(ServerIP:string;ServerPort:integer):integer;
var i,j:integer;
begin
j := -1;
for i := 0 to (length(linkedservers) -1) do
begin
if ((linkedservers[i].HubIP = ServerIP) and (linkedservers[i].HubPort = ServerPort) and (linkedservers[i].HubStatus = 2)) then j := i;
end;
result := j;
end;


end.
