{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: global_multiconsol_functions.pas,v 0.1 2002/01/03 16:30 suxxx $
}

{ here all multiconsole functions stored }

{
todos:
* cleaning code
}

unit global_multiconsol_functions;

interface
uses  { opendcd units }
      declare_types,
      declare_vars;
      
function InitConsole(ConsoleType : integer) :integer;
procedure SwitchToLoggingScreen(ConsoleType : integer;Consolenumber : integer);
procedure SwitchToChatScreen(ConsoleType : integer;Consolenumber : integer);
procedure ConsoleWrite(Text:string; Screen:integer;ConsoleType : integer;Consolenumber : integer;const NoDisplay:boolean = false);
procedure ConsoleWriteln(Text:string; Screen:integer;ConsoleType : integer;Consolenumber : integer;const NoDisplay:boolean = false);

implementation

{
Idea and Base Functions by TerRoshak.
Many Changes and Bugfixes ;) by SuxXx;)
}

// Multi Console Init
function InitConsole(ConsoleType : integer) :integer;
var i:integer;
begin
//ConsoleType: 0 = Local / 1 = Remote (telnet not supported yet)
if ConsoleType = 0 then
begin
 LocalConsole.LoggingScreenEnabled := false;
 for i := 0 to 24 do
 begin
  LocalConsole.CommandScreenBuf[i] := '';
  LocalConsole.LoggingScreenBuf[i] := '';
 end;
end;
if ConsoleType = 1 then
begin
 //ExternalConsole
end;
result := 1;
end;

procedure SwitchToLoggingScreen(ConsoleType : integer;Consolenumber : integer);
var i:integer;
begin
//ConsoleType: 0 = Local / 1 = Remote (telnet not supported yet)
if ConsoleType = 0 then
begin
 LocalConsole.LoggingScreenEnabled  := true;
 for i := 0 to 24 do
 begin
  writeln(LocalConsole.LoggingScreenBuf[i]);
 end;
 readln;
 LocalConsole.LoggingScreenEnabled  := false;
 for i := 0 to 24 do
 begin
  writeln(LocalConsole.CommandScreenBuf[i]);
 end;
end;
if ConsoleType = 1 then
begin
 //ExternalConsole
end;
end;

procedure SwitchToChatScreen(ConsoleType : integer;Consolenumber : integer);
var i:integer;
    instring:string;
begin
//ConsoleType: 0 = Local / 1 = Remote (telnet not supported yet)
if ConsoleType = 0 then
begin
 LocalConsole.ChatScreenEnabled  := true;
 for i := 0 to 24 do
 begin
  writeln(LocalConsole.ChatScreenBuf[i]);
 end;
 while instring <> '/q' do
 begin
  readln(instring);
  if(instring <> '') then
  begin
   if(instring <> '/q') then
   begin
    DCHub.DCCMD_SendBroadCastMsg('<Admin> ' + instring);
    ConsoleWriteln('[CHAT] <Admin> ' + instring,2,0,Consolenumber);
   end;
  end;
 end;
 LocalConsole.ChatScreenEnabled  := false;
 for i := 0 to 24 do
 begin
  writeln(LocalConsole.CommandScreenBuf[i]);
 end;
end;
if ConsoleType = 1 then
begin
 //ExternalConsole
end;
end;

procedure ConsoleWriteln(Text:string; Screen:integer;ConsoleType : integer;Consolenumber : integer;const NoDisplay:boolean = false);
begin
//Screen: 0 = Commandscreen / 1 = Loggingscreen / 2 = chatscreen
//ConsoleType: 0 = Local / 1 = Remote (telnet not supported yet)
if (Text <> '') then
begin
if ConsoleType = 0 then
begin
 if Screen = 0 then
 begin
  move(LocalConsole.CommandScreenBuf[1],LocalConsole.CommandScreenBuf[0],25*120);
  LocalConsole.CommandScreenBuf[24] := LocalConsole.CommandScreenTmpBuffer + Text;
  LocalConsole.CommandScreenTmpBuffer := '';
  if not Localconsole.LoggingScreenEnabled then if NoDisplay = false then writeln(Text);
 end;
 if Screen = 1 then
 begin
  move(LocalConsole.LoggingScreenBuf[1],LocalConsole.LoggingScreenBuf[0],25*120);
  LocalConsole.LoggingScreenBuf[24] := LocalConsole.LoggingScreenTmpBuffer + Text;
  LocalConsole.LoggingScreenTmpBuffer := '';
  if Localconsole.LoggingScreenEnabled then if NoDisplay = false then writeln(Text);
 end;
 if Screen = 2 then
 begin
  move(LocalConsole.ChatScreenBuf[1],LocalConsole.ChatScreenBuf[0],25*120);
  LocalConsole.ChatScreenBuf[24] := LocalConsole.ChatScreenTmpBuffer + Text;
  LocalConsole.ChatScreenTmpBuffer := '';
  if Localconsole.ChatScreenEnabled then if NoDisplay = false then writeln(Text);
 end;
end;
if ConsoleType = 1 then
begin
 //ExternalConsole
end;
end;
end;

procedure ConsoleWrite(Text:string; Screen:integer;ConsoleType : integer;Consolenumber : integer;const NoDisplay:boolean = false);
begin
//Screen: 0 = Commandscreen / 1 = Loggingscreen / 2 = chatscreen
//ConsoleType: 0 = Local / 1 = Remote (telnet not supported yet)
if (Text <> '') then
begin
if ConsoleType = 0 then
begin
 if Screen = 0 then
 begin
  LocalConsole.CommandScreenTmpBuffer := LocalConsole.CommandScreenTmpBuffer + Text;
  if not Localconsole.LoggingScreenEnabled then if NoDisplay = false then write(Text);
 end;
 if Screen = 1 then
 begin
  LocalConsole.LoggingScreenTmpBuffer := LocalConsole.LoggingScreenTmpBuffer + Text;
  if Localconsole.LoggingScreenEnabled then if NoDisplay = false then write(Text);
 end;
 if Screen = 2 then
 begin
  LocalConsole.ChatScreenTmpBuffer := LocalConsole.ChatScreenTmpBuffer + Text;
  if Localconsole.ChatScreenEnabled then if NoDisplay = false then write(Text);
 end;
end;
if ConsoleType = 1 then
begin
 //ExternalConsole
end;
end;
end;


end.
