{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: global_reguser_functions.pas,v 0.1 2002/01/03 16:30 suxxx $
}

{ here all registered users functions tored }

unit global_reguser_functions;

interface
uses
     { kylix / delphi units }
     SysUtils,
     { opendcd units }
     declare_types,
     declare_vars;

function LoadRegUserlist():string;
procedure SaveRegUserlist();
function adduser(username:string;password:string;usertyp:char = 'U'):boolean;
function removeuser(username:string;password:string;internal:boolean):boolean;
function changepassword(username:string;newpassword:string):boolean;
function validateuser(username:string;password:string):integer;
function getusertype(username:string):char;
function setusertype(username:string;newtyp:char):boolean;

implementation


{ loading registered userlist }
function LoadRegUserlist():string;
var MyFile:file;
    i:integer;
    tmpUserlist:TRegUsers;
begin
AssignFile (MyFile,'userdb.dat');
setlength(RegisteredUsers,0);
if (fileexists('userdb.dat') = true) then
begin
reset(MyFile,1);
if (FileSize(MyFile) >= sizeof(tmpUserlist))  then
begin

i := 1;
while (i < FileSize(MyFile)) do
begin
blockread(MyFile,tmpUserlist,sizeof(tmpUserlist));
setlength(RegisteredUsers,length(RegisteredUsers) +1);
RegisteredUsers[length(RegisteredUsers) - 1] := tmpUserlist;
i := i + sizeof(tmpUserlist);
end;
result := inttostr(length(RegisteredUsers)) + ' Users loaded';
end;
end;
end;

{saving registered user list}
procedure SaveRegUserlist();
var MyFile:file;
    i:integer;
    tmpUserlist:TRegUsers;
begin
AssignFile (MyFile,'userdb.dat');
Rewrite(MyFile, 1);
for i := 0 to length(RegisteredUsers) -1 do
begin
tmpUserlist := RegisteredUsers[i];
Blockwrite(MyFile,tmpUserlist,sizeof(tmpUserlist));
end;
end;

{changes password of user}
function changepassword(username:string;newpassword:string):boolean;
var okdone : boolean;
    i:integer;
begin
okdone := false;
for i := 0 to length(RegisteredUsers) -1 do
begin
 if uppercase(RegisteredUsers[i].Username) = uppercase(username) then
 begin
  RegisteredUsers[i].Password := newpassword;
  okdone := true;
  break;
 end;
end;
result := okdone;
end;


{adding user to userlist}
{default usertype is user}
function adduser(username:string;password:string;usertyp:char = 'U'):boolean;
var i:integer;
    readytoadd:boolean;
begin
result := false;
readytoadd := true;
for i := 0 to length(RegisteredUsers) -1 do
begin
 if uppercase(RegisteredUsers[i].Username) = uppercase(username) then readytoadd := false;
end;
if (readytoadd = true) then
begin
setlength(RegisteredUsers,length(RegisteredUsers) +1);
RegisteredUsers[length(RegisteredUsers) - 1].Username := username;
RegisteredUsers[length(RegisteredUsers) - 1].Password := password;
RegisteredUsers[length(RegisteredUsers) - 1].UserType := usertyp;
result := true;
end;
end;

{removing user from userlist}
function removeuser(username:string;password:string;internal:boolean):boolean;
var i,index,count:integer;
    done:boolean;
begin
index := -1;
count := length(RegisteredUsers);
done := false;

 for i := 0 to (count -1) do
 begin
  if uppercase(RegisteredUsers[i].username) = uppercase(username) then
  begin
   if internal = true then
   begin
    index := i;
    break;
   end
   else
   begin
    if RegisteredUsers[i].Password = password then
    begin
     index := i;
     break;
    end
    else
    begin
     index := -1;
     break;
    end;
   end;
  end;
 end;

 if (index <> -1) then
 begin
  if count = 1 then
  begin
   setlength(RegisteredUsers,0);
  end
  else
  begin
   move(RegisteredUsers[index +1],RegisteredUsers[index], (count - index) * sizeof(TRegUsers));
   setlength(RegisteredUsers,count -1);
  end;
  done := true;
 end
 else
 begin
  done := false;
 end;
 
result := done;
end;

{validate username and password}
function validateuser(username:string;password:string):integer;
var i:integer;
    tmprcode:integer;
begin
tmprcode := 0;  // user not found

for i := 0 to (length(RegisteredUsers) -1) do
begin
     if uppercase(RegisteredUsers[i].username) = uppercase(username) then
     begin
     if RegisteredUsers[i].password = password then
     begin
      tmprcode := 1;  //password is correct
      break;
     end
     else
     begin
      tmprcode := 2;  //password is wrong
      break;
     end;
     end;
end;
result := tmprcode;
end;

{get userlevel of a user}
function getusertype(username:string):char;
var i:integer;
    tmprcode :char;
begin
tmprcode := 'E';
for i := 0 to (length(RegisteredUsers) -1) do
begin
 if uppercase(RegisteredUsers[i].username) = uppercase(username) then
 begin
  tmprcode := RegisteredUsers[i].UserType;
  break;
 end;
end;
result := tmprcode;
end;


{set userlevel of a user}
function setusertype(username:string;newtyp:char):boolean;
var i:integer;
    tmprcode:boolean;
begin
tmprcode := false;
for i := 0 to (length(RegisteredUsers) -1) do
begin
 if uppercase(RegisteredUsers[i].username) = uppercase(username) then
 begin
  RegisteredUsers[i].UserType := newtyp;
  tmprcode := true;
  break;
 end;
end;
result := tmprcode;
end;


end.
