{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: global_services.pas,v 0.6 2002/01/03 16:30 suxxx $
}

{here all services stored}

{
changes:
* 0.6 improved ooperserv, new dchub class changes
* 0.5 added operserv
* 0.4 bugfix while deleting memos
* 0.3 adding memoserv
* 0.2 first release
}


unit global_services;

interface
uses
  SysUtils,
  declare_types,
  declare_vars,
  IdBaseComponent,
  global_reguser_functions,
  global_multiconsol_functions,
  global_ban_functions,
  global_memo_functions,
  global_functions,
  IdComponent,
  IdTCPServer;

procedure service(msg:string;socket:TIdPeerThread);
procedure nickserv(command:string;socket:TIdPeerThread);
procedure memoserv(command:string;socket:TIdPeerThread);
procedure linksserv(command:string;socket:TIdPeerThread);
procedure operserv(command:string;socket:TIdPeerThread);
implementation



procedure service(msg:string;socket:TIdPeerThread);
var servicename,command:string;
begin

if pos(' ',msg) > 0 then
begin
 servicename := copy(msg,2,pos(' ',msg) -2);
 command := copy(msg,pos(' ',msg) + 1,length(msg));
end
else
begin
 servicename := copy(msg,2,length(msg));
 command := '';
end;
if servicename = 'nickserv' then nickserv(command,socket);
if servicename = 'memoserv' then memoserv(command,socket);
if servicename = 'ns' then nickserv(command,socket);
if servicename = 'ms' then memoserv(command,socket);
if servicename = 'links' then linksserv(command,socket);
if servicename = 'operserv' then operserv(command,socket);
if servicename = 'os' then operserv(command,socket);
end;

// *********** NickServ commands
procedure nickserv(command:string;socket:TIdPeerThread);
var cmd,subcmd:string;
    i:integer;
begin
if command = '' then command := 'help'; //default command = help
i := DCHub.DCCMD_GetArrayOffsetbySocket(socket);
if pos(' ',command) > 0 then
begin
 cmd := copy(command,1,pos(' ',command) -1);
 subcmd := copy(command,pos(' ',command) + 1,length(command));
end;
if pos(' ',command) = 0 then
begin
 cmd := command;
 subcmd := '';
end;
// start prase
if cmd = 'help' then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv>             ********* Nickserv Help *********');
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> %nickserv help                                           help page');
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> %nickserv register password                     register name');
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> %nickserv unregister password                 unregister name');
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> %nickserv changepw newpassword          change password');
end
else if cmd = 'changepw' then
begin
if changepassword(PConnectedUser(DCHub.HubUsers.Items[i])^.Username,subcmd) = true then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Your Password successfuly changed!');
ConsoleWriteln('[NICKSERV] Password change for Nickname: ' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username,1,0,0);
end
else
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Error while changing password!');
end;
end
else if cmd = 'register' then
begin
if adduser(PConnectedUser(DCHub.HubUsers.Items[i])^.Username,subcmd) = true then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Your Username has been successfully registered!');
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Your Username is now password protected.');
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> You now be able to use memoserv to send offline messages to other registered users. Insert "%memoserv help" to get informations about memoserv.');
PConnectedUser(DCHub.HubUsers.Items[i])^.Password := subcmd;
ConsoleWriteln('[NICKSERV] New User added! Nickname: ' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username,1,0,0);
end
else
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Error while registering');
end;
end
else if cmd = 'unregister' then
begin
if removeuser(PConnectedUser(DCHub.HubUsers.Items[i])^.Username,subcmd,false) = true then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Your Username has been successfully unregistered!');
ConsoleWriteln('[NICKSERV] A User removed! Nickname: ' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username,1,0,0);
end
else
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Nickserv> Error while unregistering');
end;
end;
end;

// *********** MemoServ commands
procedure memoserv(command:string;socket:TIdPeerThread);
var cmd,subcmd,subcmd2:string;
    i,n,j:integer;
begin
if command = '' then command := 'help'; //default command = help
i := DCHub.DCCMD_GetArrayOffsetbySocket(socket);

if (validateuser(PConnectedUser(DCHub.HubUsers.Items[i])^.Username,PConnectedUser(DCHub.HubUsers.Items[i])^.password) <> 1) then
begin
 DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> You have no rights to use memoserv.');
 exit;
end;

if pos(' ',command) > 0 then
begin
 cmd := copy(command,1,pos(' ',command) -1);
 subcmd := copy(command,pos(' ',command) + 1,length(command));
end;
if pos(' ',command) = 0 then
begin
 cmd := command;
 subcmd := '';
end;
// start prase
if cmd = 'help' then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv>             ********* Memoserv Help *********');
DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv>  %memoserv help			Displays MemoServ Help');
DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv>  %memoserv list			List all Memos');
DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv>  %memoserv read <memo-num>		Read Memo Number <memo-num>');
DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv>  %memoserv del <memo-num>		Delete Memo Number <memo-num>');
DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv>  %memoserv send <user> <text>          Sends a Memo to <user> with <text>. Max length of <text> = 160 chars');
end
else if cmd = 'list' then
begin
j := 0;
for n := 0 to length(memos) - 1 do
begin
 if (PConnectedUser(DCHub.HubUsers.Items[i])^.Username = memos[n].ToUser) then
 begin
  inc(j);
  if (j = 1) then DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Messages:');
  if (j = 1) then DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> -----------------------------------------');
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> ' + inttostr(j) + '. ' + memos[n].fromuser + ' ' + memos[n].SendDate + '');
  end;
end;
if (j > 0 ) then DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> -----------------------------------------');
if (j > 0 ) then DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Insert "%memoserv read <msgnum>" to read a Message or insert "%memoserv del <msgnum>" to delete a Message.');
if (j = 0 ) then DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> You have no Messages');    
end
else if cmd = 'read' then
begin
j := 0;
for n := 0 to length(memos) -1 do
begin
 if (PConnectedUser(DCHub.HubUsers.Items[i])^.Username = memos[n].ToUser) then
 begin
  inc(j);
  if (inttostr(j) = subcmd) then
  begin
   memos[n].Readed := true;
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Message (' + subcmd + '):');
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> -----------------------------------------');
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> From: ' + memos[n].fromuser + '');
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Sended: ' + memos[n].SendDate + '');
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Message: ' + memos[n].TextMessage + '');
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> -----------------------------------------');
  end;
  end;
end;
end
else if cmd = 'del' then
begin
j := 0;
for n := 0 to length(memos) - 1 do
begin
 if (PConnectedUser(DCHub.HubUsers.Items[i])^.Username = memos[n].ToUser) then
 begin
  inc(j);
  if (inttostr(j) = subcmd) then
  begin
   if (removememo(PConnectedUser(DCHub.HubUsers.Items[i])^.Username,strtoint(subcmd)) = true) then
   begin
    DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Message (' + subcmd + ') sucessfully deleted!');
   end
   else
   begin
    DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Message (' + subcmd + ') could not deleted!');
   end;
  end;
  end;
end;
end
else if cmd = 'send' then
begin
subcmd2 := copy(subcmd,1,pos(' ',subcmd) - 1);
subcmd := copy(subcmd, pos(' ',subcmd)+1,length(subcmd));
if (subcmd2 = '') then
begin
 DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Bad Commandline, insert "%memoserv help" for help with Memoserv.');
end
else
begin
 if (validateuser(subcmd2,'') = 0) then
 begin
  DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Error: User "' + subcmd2 +  '" does not exist');
 end
 else
 begin
  if (length(subcmd) <= 160) then
  begin
   addmemo(PConnectedUser(DCHub.HubUsers.Items[i])^.Username,subcmd2,subcmd,timetostr(time) + ' ' + datetostr(date));
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Ok, Message for "' + subcmd2 + '" will be delivered.');
   DcHub.DCCMD_SendToUserMsg(DCHub.DCCMD_GetSocketbyUsername(subcmd2),'<Memoserv> You got a new Memo from: "' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username + '". Insert %memoserv list to list all Memos.');
  end
  else
  begin
   DCHub.DCCMD_SendToUserMsg(socket,'<Memoserv> Error: Your Message is to long! (Max 160 chars)')
  end;
 end;
end;
end;
end;

// *********** Linksserv commands
procedure linksserv(command:string;socket:TIdPeerThread);
var i:integer;
    status:string;
begin
if length(linkedservers) > 0 then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Linksserv> This Hub is linked with these Hubs:');
for i := 0 to (length(linkedservers) -1) do
begin
 if linkedservers[i].HubStatus = 2 then
 begin
  status := 'ONLINE ';
 end
 else
 begin
  status := 'OFFLINE';
 end;
  DCHub.DCCMD_SendToUserMsg(socket,'<Linksserv> ' + status + ' -> ' + linkedservers[i].HubIP + ':' + inttostr(linkedservers[i].hubPort) + '')
end;
end
else
begin
 //
end;
end;

// *********** Operserv commands
procedure operserv(command:string;socket:TIdPeerThread);
var cmd,subcmd,subcmd2:string;
    i,j:integer;
begin
if command = '' then command := 'help'; //default command = help
i := DCHub.DCCMD_GetArrayOffsetbySocket(socket);

if (getusertype(PConnectedUser(DCHub.HubUsers.Items[i])^.Username) <> 'O') then
begin
 if (getusertype(PConnectedUser(DCHub.HubUsers.Items[i])^.Username) <> 'M') then
 begin
  DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> You have no rights to use operserv.');
  exit;
 end;
end;

if pos(' ',command) > 0 then
begin
 cmd := copy(command,1,pos(' ',command) -1);
 subcmd := copy(command,pos(' ',command) + 1,length(command));
end;
if pos(' ',command) = 0 then
begin
 cmd := command;
 subcmd := '';
end;
//start prase
if cmd = 'help' then
begin
DCHub.DCCMD_SendToUserMsg(socket,'<Operserv>             ********* Operserv Help *********');
DCHub.DCCMD_SendToUserMsg(socket,'<Operserv>  %operserv help			Displays Operserv Help');
DCHub.DCCMD_SendToUserMsg(socket,'<Operserv>  %operserv kick <username>		Kicks a User');
DCHub.DCCMD_SendToUserMsg(socket,'<Operserv>  %operserv ban <username> <time in sec>	Bans a User');
DCHub.DCCMD_SendToUserMsg(socket,'<Operserv>  %operserv uban <username>                         Unban a User');
 {master onyl commands}
 if (getusertype(PConnectedUser(DCHub.HubUsers.Items[i])^.Username) = 'M') then
 begin
  DCHub.DCCMD_SendToUserMsg(socket,'<Operserv>  %operserv chtype <username> <newtype> Changes the usertype of a User');

 end;
end
else if cmd = 'kick' then
begin
   if (subcmd = '') then
   begin
    DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> You must insert a Nickname to kick.');
   end
   else
   begin

    if DCHub.DCCMD_IsOnline(subcmd) = false then
    begin
     DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Nickname not found');
    end
    else
    begin
     DcHub.DCCMD_SendToUserMsg(DCHub.DCCMD_GetSocketbyUsername(subcmd),'<Operserv> You where kicked by: "' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username + '".');
     ConsoleWriteln('[OPERSERV] A User kicked! Nickname: ' + subcmd,1,0,0);
     DCHub.DCCMD_KickUser(DCHub.DCCMD_GetSocketbyUsername(subcmd));
     DcHub.DCCMD_SendToUserMsg(socket,'<Operserv> User "' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username + '" has been kicked successfully.');
    end;
   end;
end
else if cmd = 'ban' then
begin
   if (subcmd = '') then
   begin
    DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> You must insert a Nickname to ban.');
   end
   else
   begin
   subcmd2 := copy(subcmd,1,pos(' ',subcmd) - 1);
   subcmd := copy(subcmd, pos(' ',subcmd)+1,length(subcmd));
   if subcmd2 = '' then subcmd2 := subcmd;
   if DCHub.DCCMD_IsOnline(subcmd2) = false then
    begin
     DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Nickname not found');
    end
    else
    begin 
     DcHub.DCCMD_SendToUserMsg(DCHub.DCCMD_GetSocketbyUsername(subcmd2),'<Operserv> You where banned by: "' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username + '".');
     ConsoleWriteln('[OPERSERV] A User banned! Nickname: ' + subcmd2,1,0,0);
     J := DCHub.DCCMD_GetArrayOffsetbySocket(DCHub.DCCMD_GetSocketbyUsername(subcmd2));
     if (Isanumber(subcmd)) then
     begin
      AddBannedUser(PConnectedUser(DCHub.HubUsers.Items[j])^.Username,PConnectedUser(DCHub.HubUsers.Items[j])^.RemoteIP,strtoint(subcmd));
      DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Sucessfully added to banlist');
     end
     else
     begin
      AddBannedUser(PConnectedUser(DCHub.HubUsers.Items[j])^.Username,PConnectedUser(DCHub.HubUsers.Items[j])^.RemoteIP,3600);
      DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Sucessfully added to banlist');
     end;
    end;
    end;
end
else if cmd = 'uban' then
begin
   if (subcmd = '') then
   begin
    DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> You must insert a Nickname to unban.');
   end
   else
   begin
     if RemoveBannedUser(subcmd,subcmd) = false then
     begin
      DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Could not unban Nickname(User / IPAddress not found??)');
     end
     else
     begin
      DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Sucessfully removed from banlist');
      ConsoleWriteln('[OPERSERV] A User unbanned! Nickname/IP: ' + subcmd,1,0,0);
     end;
    end;
end
else if ((cmd = 'chtype') and (getusertype(PConnectedUser(DCHub.HubUsers.Items[i])^.Username) = 'M')) then
begin
   subcmd2 := copy(subcmd,1,pos(' ',subcmd) - 1);
   subcmd := copy(subcmd, pos(' ',subcmd)+1,length(subcmd));
   if ((subcmd = '') or (subcmd2 = '')) then
   begin
    DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> You must insert a Nickname and a new usertype.');
   end
   else
   begin
    if ((uppercase(subcmd[1]) = 'M') or (uppercase(subcmd[1]) = 'O') or (uppercase(subcmd[1]) = 'U')) then
    begin
     if setusertype(subcmd2,uppercase(subcmd[1])[1]) = true then
       DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> User "' + subcmd2 + '" has now the usertyp: ' + getusertype(subcmd2))
     else
       DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> User "' + subcmd2 + '" not exist.');
    end
    else
    begin
     DCHub.DCCMD_SendToUserMsg(socket,'<Operserv> Only this usertypes available: U = Normal User, O = Operator, M = Master');
    end;
   end;
end;
end;
end.
