{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: opendcd.dpr,v 0.7 2002/03/26 15:50 suxxx $
}

{ thats the main unit. here all other units / classes will be inizialised ]
{ and here is the consol handeling stored } 

{
general todos:
* some changes in the dc_server_server.pas to allow linking via dnsnames too
  
changes:
* 0.7 fixed crashbug after the first configure of the server, fixed bug in the "say" command
* 0.6 changing commands that they have a commandline
* 0.2 to 0.5 adding some commands
* 0.1 first release
}

program opendcd;

{$APPTYPE CONSOLE}
 
uses
  SysUtils,
  {$IFDEF LINUX} Libc, {$ENDIF}
  declare_types,
  declare_vars,
  global_functions,
  global_multiconsol_functions,
  global_reguser_functions,
  global_linkedserver_functions,
  global_ban_functions,
  global_memo_functions,
  dc_client_server,
  dc_server_server,
  dc_public_server_reg,
  odc_autosavesettings;

var MyFile:file;
    readstr:string;
    readstrarray:stringarray;
    TmpString:string;
    i,n:integer;
    tmpstr:string;
    tmpstr2:string;
    DCPublicRegister:TDCPublicRegister;
    ODCAutosaveSettings:TODCAutosaveSettings;
    {$IFDEF LINUX} SigActionRec : TSigAction;{$ENDIF}
label restartserver;
begin
 { broken pipe ignore functions
   * for Linux only
   * Code from Ronald Eckerberger
 }
 {$IFDEF LINUX}
 with SigActionRec do
 begin
  __sigaction_handler := TSigActionHandler(SIG_IGN);
  sigemptyset(sa_mask);
  sa_flags := 0;
  sigaction(SIGPIPE, @SigActionRec,nil);
 end;
 {$ENDIF}
 {/ broken pipe ignore functions }


 DetectOSVersion;
 InitConsole(0);

 {creating array with users that not allowed to join opendcd}
 AddIllegalUser('Admin');
 AddIllegalUser('Hub');
 AddIllegalUser('Hub-Security');
 AddIllegalUser('MOTD');
 AddIllegalUser('System');
 
 AddIllegalUser('Nickserv');
 AddIllegalUser('Memoserv');
 AddIllegalUser('Linksserv');
 AddIllegalUser('Operserv');

 AddIllegalUser('unknown');

 DCPublicRegister := TDCPublicRegister.Create;
 ODCAutosaveSettings := TODCAutosaveSettings.Create;
 
 {init readstrarray}
 setlength(readstrarray,0);

 ConsoleWriteln('openDCd version ' + OpenDCdVersion + ' running at: ' + OSVersion,0,0,0);
 ConsoleWriteln('[LOG] ***** Logwindow *****',1,0,0);
 ConsoleWriteln('[LOG] (Press return to switch to commandmode)',1,0,0);
 ConsoleWriteln('[Chat] ***** Chatwindow *****',2,0,0);
 ConsoleWriteln('[Chat] (insert "/q" to switch to commandmode)',2,0,0);

 restartserver:
 AssignFile (MyFile,'settings.dat');
 if fileexists('settings.dat') = false then
 begin
  setupserver;
 end
 else
 begin
  reset(MyFile,1);
  BlockRead(MyFile,HubSettings,sizeof(HubSettings));
  CloseFile(MyFile);
 end;



 ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
 ConsoleWriteln('OpenDCd Settings:',0,0,0);
 ConsoleWriteln('Hubname: ' + HubSettings.HubName,0,0,0);
 ConsoleWriteln('HubPort: ' + inttostr(HubSettings.HubPort),0,0,0);
 ConsoleWriteln('MaxUsers: ' + inttostr(HubSettings.HubMaxUsers),0,0,0);
 ConsoleWriteln('Minfileshare: ' + inttostr(HubSettings.HubMinFileShare),0,0,0);
 ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);

 ConsoleWriteln(LoadRegUserlist(),0,0,0);
 ConsoleWriteln(LoadLinkedServer(),0,0,0);
 ConsoleWriteln(loadmemos(),0,0,0);



 try

  DCHub := TDCHub.Create ('',HubSettings.HubPort);
  ConsoleWrite('Init Server..',0,0,0);
 except
   ConsoleWrite('Init Server.?',0,0,0);
 end;

 ConsoleWrite('.',0,0,0);
 
 { assign hubsetting to the hub }
 DCHub.HubName := HubSettings.HubName;
 DCHub.HubMaxUsers := HubSettings.HubMaxUsers;
 DCHub.HubMinFileShare := HubSettings.HubMinFileShare;
 DCHub.HubRedirectAddress := HubSettings.HubRedirectAddress;
 DCHub.HubRedirectAllUsers := HubSettings.HubRedirectAllUsers;
 DCHub.HubRedirectIfHubIsFull := HubSettings.HubRedirectIfHubIsFull;
 DCHub.HubIsRegisteredUsersOnly := HubSettings.HubIsRegisteredUsersOnly;
 DCHub.HubDisablePassiveSearch := HubSettings.HubDisablePassiveSearch;
 

 try
  DCHub.HubTCPListenerActive := true;
  ConsoleWriteLn('done',0,0,0);
 except
 ConsoleWriteLn('faild',0,0,0);
  ConsoleWriteLn('Could not activate listeners.',0,0,0);
  ConsoleWriteLn('Please change Port or close other Deamons listen on Port ' + inttostr(HubSettings.HubPort) + '.',0,0,0);
  ConsoleWriteLn('Insert "quit" to close openDCd or "setup" to reconfigure openDCd.',0,0,0);
 end;

while true do
begin
 ConsoleWrite('OpenDCd>',0,0,0);
 readln(readstr);

 {setting readstr to ' ' when empty, that ConsoleWriteln add a LF}
 if readstr = '' then readstr := ' ';

 ConsoleWriteln(readstr,0,0,0,true);

 readstrarray := splitstring(readstr);


 if length(readstrarray) > 0 then
 begin

  // GENERAL COMMANDS

  // ** quit
  if (readstrarray[0] = 'quit') then
  begin
   DCHub.DCCMD_SendBroadCastMsg('<Hub-Security> This Hub is going down now!');
   sleep(1000);
   ConsoleWrite('Closing Server...',0,0,0);
   SaveRegUserlist();
   savememos();
   savelinkedserver();
   DCHub.DCCMD_KickAllUsers;
   try
    DCHub.HubTCPListenerActive := false;
    ConsoleWriteLn('done',0,0,0);
   except
    ConsoleWriteLn('faild',0,0,0);
   end;
   DCHub.Destroy;
   DCPublicRegister.Destroy;
   ODCAutosaveSettings.Destroy;
   break;
  end

  // ** restart
  else if (readstrarray[0] = 'restart') then
  begin
   DCHub.DCCMD_SendBroadCastMsg('<Hub-Security> This Hub is going down for restart!');
   sleep(1000);
   ConsoleWrite('Closing Server...',0,0,0);
   SaveRegUserlist();
   savememos();
   savelinkedserver();
   DCHub.DCCMD_KickAllUsers;
   try
    DCHub.HubTCPListenerActive := false;
    ConsoleWriteLn('done',0,0,0);
   except
    ConsoleWriteLn('faild',0,0,0);
   end;

   DCHub.Destroy;
   goto restartserver;
  end

  // ** setup
  else if (readstrarray[0] = 'setup') then
  begin
   setupserver;
   DCHub.HubName := HubSettings.HubName;
   DCHub.HubMaxUsers := HubSettings.HubMaxUsers;
   DCHub.HubMinFileShare := HubSettings.HubMinFileShare;
   DCHub.HubRedirectAddress := HubSettings.HubRedirectAddress;
   DCHub.HubRedirectAllUsers := HubSettings.HubRedirectAllUsers;
   DCHub.HubRedirectIfHubIsFull := HubSettings.HubRedirectIfHubIsFull;
   DCHub.HubIsRegisteredUsersOnly := HubSettings.HubIsRegisteredUsersOnly;
   DCHub.HubDisablePassiveSearch := HubSettings.HubDisablePassiveSearch;
   ConsoleWriteln('You must restart OpenDCd to activate a HubPort change.',0,0,0);
  end
  
  // ** status
  else if (readstrarray[0] = 'status') then
  begin

   ConsoleWriteln('Connections: ' + inttostr(DCHub.HubUsers.Count),0,0,0);

   n := 0;
   for i := 0 to DCHub.HubUsers.Count -1 do
   begin
      if PConnectedUser(DCHub.HubUsers.Items[i])^.SuccessLoggedIn = true then inc(n);
   end;

   ConsoleWriteln('Users: ' + inttostr(n),0,0,0);

   for i := 0 to DCHub.HubUsers.Count -1 do
   begin
      ConsoleWriteln(inttostr(i +1) + '. ' + PConnectedUser(DCHub.HubUsers.Items[i])^.Username + ' (' + PConnectedUser(DCHub.HubUsers.Items[i])^.RemoteIP + ')',0,0,0);
   end;
  end

  // ** goto logmode

  else if (readstrarray[0] = 'log') then
  begin
   SwitchToLoggingScreen(0,0);
  end

  else if (readstrarray[0] = 'chat') then
  begin
   SwitchToChatScreen(0,0);
  end

  // ** say
  else if (readstrarray[0] = 'say') then
  begin
   if length(readstrarray) < 2 then
   begin
    ConsoleWriteLn('Sends a broadcast message to all connected users.',0,0,0);
    ConsoleWriteLn('Commandline: say <textmessage to send>',0,0,0);
   end
   else
   begin
    TmpString := '';
    for i := 1 to length(readstrarray) - 1 do TmpString := TmpString + ' ' + readstrarray[i];
    DCHub.DCCMD_SendBroadCastMsg('<Admin> ' + TmpString)
   end;
  end

  // ** kick
  else if (readstrarray[0] = 'kick') then
  begin
   if length(readstrarray) <> 2 then
   begin
    ConsoleWriteLn('Kicks a spezific user from the server',0,0,0);
    ConsoleWriteLn('Commandline: kick <username>',0,0,0);
   end
   else
   begin
    if DCHub.DCCMD_KickUser(DCHub.DCCMD_GetSocketbyUsername(readstrarray[1])) = true then
     ConsoleWriteln('User successfully kicked!',0,0,0)
    else
     ConsoleWriteln('Could not kick user. (username not found) ',0,0,0);
   end;
  end

  // **redirect 
  else if (readstrarray[0] = 'redirect') then
  begin
   if length(readstrarray) <> 2 then
   begin
    ConsoleWriteLn('Redirect a spezific user from the server',0,0,0);
    ConsoleWriteLn('Commandline: redirect <username>',0,0,0);
   end
   else
   begin
    if DCHub.DCCMD_RedirectUser(DCHub.DCCMD_GetSocketbyUsername(readstrarray[1])) = true then
     ConsoleWriteln('User successfully redirected!',0,0,0)
    else
     ConsoleWriteln('Could not redirect user. (username not found) ',0,0,0);
   end;
  end

  // ** redirect all
  else if (readstrarray[0] = 'redirectall') then
  begin
   if length(readstrarray) <> 1 then
   begin
    ConsoleWriteLn('Redirect all Users to the Address spezific in the setup.',0,0,0);
    ConsoleWriteLn('Commandline: redirectall',0,0,0);
   end
   else
   begin
    DCHub.DCCMD_RedirectAllUsers();
   end;
  end

  // ** kick all
  else if (readstrarray[0] = 'kickall') then
  begin
   if length(readstrarray) <> 1 then
   begin
    ConsoleWriteLn('Kicks all Users from the Hub',0,0,0);
    ConsoleWriteLn('Commandline: kickall',0,0,0);
   end
   else
   begin
    DCHub.DCCMD_KickAllUsers();
   end;
  end

 // USER COMMMANDS

  else if (readstrarray[0] = 'user') then
  begin
   if length(readstrarray) = 1 then
   begin
    ConsoleWriteLn('With the user command you could do registered user interactions.',0,0,0);
    ConsoleWriteLn('Insert "help user" for the available user commands.',0,0,0);
   end
   else
   begin
   // ** All User commands stored here!

    // list users
    if (readstrarray[1] = 'list') then
    begin
     for i := 0 to length(RegisteredUsers) -1 do
     begin
      ConsoleWriteln(inttostr(i +1) + '. ' + RegisteredUsers[i].Username + ' (' + RegisteredUsers[i].UserType + ')',0,0,0);
     end;
    end

    // add user
    else if (readstrarray[1] = 'add') then
    begin
     if length(readstrarray) <> 4 then
     begin
      ConsoleWriteLn('With the user add command you could add a new registered user.',0,0,0);
      ConsoleWriteLn('Commandline: user add <username> <password>',0,0,0);
     end
     else
     begin
      if adduser(readstrarray[2],readstrarray[3]) = true then
       ConsoleWriteln ('User "' + readstrarray[2] + '" successfully added!',0,0,0)
      else
       ConsoleWriteln ('User "' + readstrarray[2] + '" could not added! (username allready exists?)',0,0,0)
     end;
    end

    // del user
    else if (readstrarray[1] = 'del') then
    begin
     if length(readstrarray) <> 3 then
     begin
      ConsoleWriteLn('With the user del command you could delete a registered user.',0,0,0);
      ConsoleWriteLn('Commandline: user del <username>',0,0,0);
     end
     else
     begin
      if removeuser(readstrarray[2],'',true) = true then
       ConsoleWriteln ('User "' + readstrarray[2] + '" successfully deleted!',0,0,0)
      else
       ConsoleWriteln ('User "' + readstrarray[2] + '" could not deleted! (username not exist?)',0,0,0)
     end;
    end
    // change password from user
    else if (readstrarray[1] = 'chpw') then
    begin
     if length(readstrarray) <> 4 then
     begin
      ConsoleWriteLn('With the user chpw command you could change a registered users password.',0,0,0);
      ConsoleWriteLn('Commandline: user chpw <username> <newpassword>',0,0,0);
     end
     else
     begin
      if changepassword(readstrarray[2],readstrarray[3]) = true then
       ConsoleWriteln ('Password from User "' + readstrarray[2] + '" successfully changed!',0,0,0)
      else
       ConsoleWriteln ('Password from User "' + readstrarray[2] + '" could not changed! (username not exist?)',0,0,0)
     end;

    end

    // chtype

    else if (readstrarray[1] = 'chtype') then
    begin
     if length(readstrarray) <> 4 then
     begin
      ConsoleWriteLn('With the user chtype command you could change the usertype of a user.',0,0,0);
      ConsoleWriteLn('This usertypes available: U = Normal User, O = Operator, M = Master',0,0,0);
      ConsoleWriteLn('Commandline: user chtype <username> <newtype>',0,0,0);
     end
     else
     begin
      if ((uppercase(readstrarray[3][1]) = 'M') or (uppercase(readstrarray[3][1]) = 'O') or (uppercase(readstrarray[3][1]) = 'U')) then
      begin
       if setusertype(readstrarray[2],uppercase(readstrarray[3][1])[1]) = true then
        ConsoleWriteln ('User "' + readstrarray[2] + '" has now the usertyp: ' + getusertype(readstrarray[2]),0,0,0)
       else
        ConsoleWriteln ('User "' + readstrarray[2] + '" not exist.',0,0,0);
      end
      else
      begin
       ConsoleWriteLn('Only this usertypes available: U = Normal User, O = Operator, M = Master',0,0,0);
      end;
    end;
   end
   else
    begin
     if readstrarray[1] <> '' then
     begin
     ConsoleWriteln('User command "' + readstrarray[1] + '" not found!',0,0,0);
     ConsoleWriteLn('With the user command you could do registered user interactions.',0,0,0);
     ConsoleWriteLn('Insert "help user" for the available user commands.',0,0,0);
     end;
    end;
    //
   end;
  end

  // LINKED Servers COMMMANDS
  else if (readstrarray[0] = 'server') then
  begin
   if length(readstrarray) = 1 then
   begin
    ConsoleWriteLn('With the server command you could add and delete links to other servers',0,0,0);
    ConsoleWriteLn('Insert "help server" for the available server commands.',0,0,0);
   end
   else
   begin
   // ** All server commands stored here!

    // list servers
    if (readstrarray[1] = 'list') then
    begin
     for i := 0 to length(linkedservers) -1 do
     begin
      if linkedservers[i].HubStatus = 2 then
      begin
       tmpstr := 'Online';
     end
     else if linkedservers[i].HubStatus = 3 then
     begin
      tmpstr := 'Offline';
     end
     else if linkedservers[i].HubStatus = 1 then
     begin
      tmpstr := 'Unknown';
     end;
      ConsoleWriteln(inttostr(i +1) + '. ' + linkedservers[i].HubIP + ':' + inttostr(linkedservers[i].HubPort) + ' ( Status: ' + tmpstr + ' )',0,0,0);
     end;
    end

    // add server
    else if (readstrarray[1] = 'add') then
    begin
     if length(readstrarray) <> 5 then
     begin
      ConsoleWriteLn('With the server add command you could add a new link to a server.',0,0,0);
      ConsoleWriteLn('Commandline: server add <serverip> <serverport> <password>',0,0,0);
     end
     else
     begin
      if AddLinkedServer(readstrarray[2],strtoint(readstrarray[3]),readstrarray[4]) = true then
       ConsoleWriteln ('Serverlink "' + readstrarray[2] + '" successfully added!',0,0,0)
      else
       ConsoleWriteln ('Serverlink "' + readstrarray[2] + '" could not added!',0,0,0)
     end;
    end

    // del server
    else if (readstrarray[1] = 'del') then
    begin
     if length(readstrarray) <> 3 then
     begin
      ConsoleWriteLn('With the server del command you could delete a link to a server.',0,0,0);
      ConsoleWriteLn('Commandline: server del <id in server list>',0,0,0);
     end
     else
     begin
      if RemoveLinkedServer(strtoint(readstrarray[2])) = true then
       ConsoleWriteln ('Serverlink "' + readstrarray[2] + '" successfully deleted!',0,0,0)
      else
       ConsoleWriteln ('Serverlink "' + readstrarray[2] + '" could not deleted!',0,0,0)
     end;
    end
    else
    begin
     if readstrarray[1] <> '' then
     begin
     ConsoleWriteln('Server command "' + readstrarray[1] + '" not found!',0,0,0);
     ConsoleWriteLn('With the server command you could add and delete links to other servers',0,0,0);
     ConsoleWriteLn('Insert "help server" for the available server commands.',0,0,0);
     end;
    end;
   //
   end;
  end

  // Banned Users COMMMANDS
  else if (readstrarray[0] = 'ban') then
  begin
   if length(readstrarray) = 1 then
   begin
    ConsoleWriteLn('With the ban command you could add and delete banned users',0,0,0);
    ConsoleWriteLn('Insert "help ban" for the available server commands.',0,0,0);
   end
   else
   begin
   // ** All ban commands stored here!

    // list banned users
    if (readstrarray[1] = 'list') then
    begin
      for i := 0 to (length(bannedusers) -1) do
      begin
       tmpstr := bannedusers[i].Username;
       tmpstr2 := bannedusers[i].IPAddress;
       if tmpstr = '' then tmpstr := '*';
       if tmpstr2 = '' then tmpstr2 := '*';
       ConsoleWriteln(inttostr(i +1) + '. ' + tmpstr + ' (' + tmpstr2 + ') Banned to: ' + datetostr(bannedusers[i].BannedTo) + ' ' + timetostr(bannedusers[i].BannedTo),0,0,0);
      end;
    end

    // add banned user name and ip
    else if (readstrarray[1] = 'add') then
    begin
     if length(readstrarray) < 4 then
     begin
      ConsoleWriteLn('With the ban add command you could add a new banned user and ip.',0,0,0);
      ConsoleWriteLn('If you insert no time, the user/ip will be banned for one hour.',0,0,0);
      ConsoleWriteLn('If you dont know the username/ip insert a * as username/ip.',0,0,0);
      ConsoleWriteLn('Commandline: ban add <username> <clientip> <time in seconds>',0,0,0);
     end
     else
     begin
      if (length(readstrarray) = 5)then
      begin
       if (Isanumber(readstrarray[4])) then
       begin
        AddBannedUser(readstrarray[2],readstrarray[3],strtoint(readstrarray[4]));
        ConsoleWriteLn('Ban has been added. Username: "' + readstrarray[2]  + '", IP: "' + readstrarray[3] + '" for: "' + readstrarray[4] + '" seconds.',0,0,0);
       end
       else
       begin
        AddBannedUser(readstrarray[2],readstrarray[3],3600);
        ConsoleWriteLn('Ban has been added. Username: "' + readstrarray[2]  + '", IP: "' + readstrarray[3] + '" for: "3600" seconds.',0,0,0);
       end;
      end
      else
      begin
       AddBannedUser(readstrarray[2],readstrarray[3],3600);
       ConsoleWriteLn('Ban has been added. Username: "' + readstrarray[2]  + '", IP: "' + readstrarray[3] + '" for: "3600" seconds.',0,0,0);
      end;
     end;
    end

    // del banned user name and ip
    else if (readstrarray[1] = 'del') then
    begin
     if length(readstrarray) < 3 then
     begin
      ConsoleWriteLn('With the ban del command you could delete a banned user and ip.',0,0,0);
      ConsoleWriteLn('If you dont know the username/ip insert a * as username/ip.',0,0,0);
      ConsoleWriteLn('Commandline: ban del <username> <clientip>',0,0,0);
     end
     else
     begin
      if (RemoveBannedUser(readstrarray[2],readstrarray[3]) = true)then
      begin
       ConsoleWriteLn('All banns for Username: "' + readstrarray[2]  + '" and IP: "' + readstrarray[3] + '" has been removed!',0,0,0);
      end;
     end;
    end
    else
    begin
     if readstrarray[1] <> '' then
     begin
     ConsoleWriteln('Ban command "' + readstrarray[1] + '" not found!',0,0,0);
     ConsoleWriteLn('With the ban command you could add and delete banned users',0,0,0);
     ConsoleWriteLn('Insert "help ban" for the available server commands.',0,0,0);
     end;
    end;
   //
   end;
  end

    // help COMMMANDS
  else if ((readstrarray[0] = 'help') or (readstrarray[0] = '?')) then
  begin
   if length(readstrarray) < 2 then
   begin
    ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
    ConsoleWriteln('Main commands:',0,0,0);
    ConsoleWriteln(' help           -       This Page',0,0,0);
    ConsoleWriteln(' log            -       Switch to Logmessages screen',0,0,0);
    ConsoleWriteln(' chat           -       Switch to Chatmessages screen',0,0,0);
    ConsoleWriteln(' setup          -       ReConfigure Server',0,0,0);
    ConsoleWriteln(' restart        -       RestartServer (Kicks all Clients)',0,0,0);
    ConsoleWriteln(' quit           -       Shutdown Server',0,0,0);
    ConsoleWriteln(' status         -       Gives a small status about the connected Users',0,0,0);
    ConsoleWriteln(' say            -       Sends a Broadcast MSG',0,0,0);
    ConsoleWriteln(' kick           -       Kicks a User',0,0,0);
    ConsoleWriteln(' redirect       -       Redirect a User',0,0,0);  
    ConsoleWriteln(' redirectall    -       Redirect all Users',0,0,0);
    ConsoleWriteln(' kickall        -       Kick all Users',0,0,0);  
    ConsoleWriteln('User commands:',0,0,0);
    ConsoleWriteln(' list, add, del, chpw, chtype',0,0,0);
    ConsoleWriteln(' To get help about the user commands insert "help user"',0,0,0);
    ConsoleWriteln('Linked server commands:',0,0,0);
    ConsoleWriteln(' list, add, del',0,0,0);
    ConsoleWriteln(' To get help about the server commands insert "help server"',0,0,0);
    ConsoleWriteln('Ban commands:',0,0,0);
    ConsoleWriteln(' list, add, del',0,0,0);
    ConsoleWriteln(' To get help about the ban commands insert "help ban"',0,0,0);
    ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
   end
   else
   begin
   // Help for the categories
    if (readstrarray[1] = 'user') then
    begin
     ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
     ConsoleWriteln('All User command start with "user" and the command',0,0,0);
     ConsoleWriteln(' list          -       List all Registered Users',0,0,0);
     ConsoleWriteln(' add           -       Adds a User to Userlist',0,0,0);
     ConsoleWriteln(' del           -       Remove a User from Userlist',0,0,0);
     ConsoleWriteln(' chpw          -       Change Users Password',0,0,0);
     ConsoleWriteln(' chtype         -       Changes Usertype',0,0,0);
     ConsoleWriteln('Examples:',0,0,0);
     ConsoleWriteln(' "user add suxxx secret" - adds a user named suxxx with password secret',0,0,0);
     ConsoleWriteln(' "user chpw suxxx doggythedog" - changes the password from suxxx to doggythedog',0,0,0);
     ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
    end
    else if (readstrarray[1] = 'server') then
    begin
     ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
     ConsoleWriteln('All Server command start with "server" and the command',0,0,0);
     ConsoleWriteln(' list          -       List all Linked Servers',0,0,0);
     ConsoleWriteln(' add           -       Adds a new Linked Server',0,0,0);
     ConsoleWriteln(' del           -       Removes a Linked Server',0,0,0);
     ConsoleWriteln('Examples:',0,0,0);
     ConsoleWriteln(' "server add 127.0.0.1 411 secret" - adds a server on ip 127.0.0.1:411 with password secret',0,0,0);
     ConsoleWriteln(' "server list" - display a list of all linked servers with status',0,0,0);
     ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
    end
    else if (readstrarray[1] = 'ban') then
    begin
     ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
     ConsoleWriteln('All Ban command start with "ban" and the command',0,0,0);
     ConsoleWriteln(' list          -       List all banned Users',0,0,0);
     ConsoleWriteln(' add           -       Adds a User to bannlist',0,0,0);
     ConsoleWriteln(' del           -       Remove a User from bannlist',0,0,0);
     ConsoleWriteln('Examples:',0,0,0);
     ConsoleWriteln(' "ban add suxxx 127.0.0.1 120" - bans the user suxxx and all users with ip 127.0.0.1 for 2 Minutes',0,0,0);
     ConsoleWriteln(' "ban list" - display a list of all banned users',0,0,0);
     ConsoleWriteln('-------------------------------------------------------------------------------',0,0,0);
    end
    else
    begin
     ConsoleWriteln('Your inserted help categorie does not exist. Only this categories available:',0,0,0);
     ConsoleWriteln('user, server, ban',0,0,0);
     ConsoleWriteln('Insert "help <categoriename>" to get help about a categorie.',0,0,0);
    end;
    
   //
   end;
   //
  end

  else
  begin
    if readstrarray[0] <> '' then ConsoleWriteln('Command "' + readstrarray[0] + '" not found!',0,0,0);
  end;
 end;



// end loop
end;


end.
