{ Copyright (C) 2001 suxxx@users.sourceforge.net
This is free software distributed under the terms of the
GNU Public License.  See the file COPYING for details.
$Id: threadtimer.pas,v 0.2 2001/12/13 19:30 suxxx $
}

{
changes:
* 0.2 fixing no termination bug (now timer terminats gracefully)
* 0.1 first version
}


{ Base Functions by TerRoshak, Optimized by SuxXx }

unit threadtimer;

interface

uses
  Classes, Sysutils;

type tthreadtimerevent = procedure of object;

type
  TThreadTimer = class(TThread)
  private
   ivall : longword;
  protected
    aevent : tthreadtimerevent;
    procedure Execute; override;

  public
   constructor Create(intervall : integer);
   property OnTimer: tthreadtimerevent read aevent write aevent;
  end;

implementation

constructor TThreadTimer.Create(intervall : integer);
begin
 inherited Create(false);
 ivall := intervall;
end;

procedure TThreadTimer.Execute;
var hour, min, sek, msek : word;
    yettime : tdatetime;
    alltime : longword;
begin
 yettime := time;
 repeat
  decodetime(time - yettime,hour,min,sek,msek);
  alltime := (hour*60*60) + (min*60) + sek;
  if (alltime >= ivall) then
  begin
   if assigned(OnTimer) then OnTimer;
   yettime := time;
  end;
  sleep(1000);
 until self.Terminated;
end;


end.




